#!/usr/bin/perl
####################################################################
#                                                                  #
#  DISCLAIMER:                                                     #
#  In no event will T. O' Donnell be liable to the user of this    # 
#  script or any third party for any damages, including any lost   #
#  profits, lost savings or other incidental, consequential or     #
#  special damages arising out of the operation of or inability to # 
#  operate this script, even if the user has been advised of the   # 
#  possibility of such damages.                                    #
####################################################################
##############################################################################
# COPYRIGHT NOTICE                                                           #
# TigerTom's Horatio Script. Version: 1.2, April 2002.                       # 
#                                                                            #  
# Copyright 2001-2002 T. O' Donnell.  All Rights Reserved.                   #
# http://www.tigertom.com/contact.htm                                        #
#                                                                            #
# This Perl script may be used and modified by any purchaser so              # 
# long as this copyright notice and the comments below remain intact.        # 
#                                                                            # 
# It may only be used on domains owned by the purchaser.                     #
#                                                                            #
# By using this code you agree to indemnify T. O' Donnell Inc. and T. O'     #
# Donnell from any liability that might arise from its use.                  #   
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.                                                       #
# You must get permission from T. O' Donnell before redistributing this      #
# software over the Internet or via any other medium.                        #
# You may not redistribute an altered version of this program in any form,   # 
# via any medium.                                                            # 
#                                                                            #
# In all cases copyright and header must remain intact.                      #
#                                                                            #                    
# This Copyright is in full effect in any country that has International     #
# Trade Agreements with the United Kingdom Of Great Britain.                 #
#                                                                            #
##############################################################################

# Horatio .htaccess error-reporting script by T. O' Donnell, July 2001.
# Copyright T. O' Donnell, July 2001.

use CGI::Carp qw(fatalsToBrowser);
require "tigertom_lib.cgi";
require "horatio_setup.cgi";
require "horatio_lib.cgi";

########################################

# read in the data
&parse_data; 

print "Content-type:  text/html\n\n";


# Then output error message:


if ($ENV{'QUERY_STRING'} =~ /405/) {
print "<H2>Method $ENV{'REQUEST_METHOD'} Not Allowed!</H2>\n";
print "Visitor, inform the administrator of this error, and tell him to check his '.htaccess file'.<BR><BR>\n";
print "<H4>Please email the Administrator <a href=\"mailto:$admin_email\">$admin_email</a>";
print "stating the error message.</H4>\n";
exit(0);
  }


if ($ENV{'QUERY_STRING'} =~ /403/) {
print "<H2>Access Forbidden!</H2>\n";
print "This directory, or some file(s) in it, have permissions set which do not allow you access.\n\n";
print "<H4>Please email the Administrator <a href=\"mailto:$admin_email\">$admin_email</a>\n";
print " if you think this is incorrect, stating the error message.</H4>\n";
exit(0);
  }

if ($ENV{'QUERY_STRING'} =~ /404/) {
print "<H2>File Not Found!</H2>\n";
print "<H4>Please email the Administrator <a href=\"mailto:$admin_email\">$admin_email</a>\n";
print " if you think this is incorrect, stating the error message.</H4>\n";
exit(0);
  }

if ($ENV{'QUERY_STRING'} =~ /401/) {
print "<H2>Bad Username or Password!</H2>\n";
print "Check your Username and Password are correct, and that CAPS LOCK is\n";
print "*Off* on your keyboard. Contact the <a href=\"mailto:$admin_email\">administrator</a>\n";
print "if you think this is an error, stating the problem.\n";
exit(0);
  }

if ($ENV{'QUERY_STRING'} =~ /bad_referer/) {
print "<H2>Error! You may not access files on this site from outside this domain, or through bookmarking. <I>You have to come via another page on this site.</I></H2>\n";
print "<H4>Please email the Administrator <a href=\"mailto:$admin_email\">$admin_email</a>\n";
print " if you think this is incorrect, stating the error message.</H4>\n";
exit(0);
  }

if ($ENV{'QUERY_STRING'} =~ /no_cookies/) {
print "<H2>Error! Browser does not seem to have cookies enabled.</H2>\n";
print "Use your browser's <B>back</B> button, enable cookies in your browser, and try again.<BR><BR>\n";
print "<H4>Please email the Administrator <a href=\"mailto:$admin_email\">$admin_email</a>\n";
print " if you think this is incorrect, stating the error message.</H4>\n";
exit(0);
  }

if ($ENV{'QUERY_STRING'} =~ /bad_browser/) {
print "<H2>Error! Browser is not Netscape 4 or IE 4 or later version, or Opera or WebTV.</H2>\n";
print "You can't use an old or unusual broswer, or download accelerator, or leech program on this site.<BR><BR>\n";
print "<H4>Please email the Administrator <a href=\"mailto:$admin_email\">$admin_email</a>\n";
print " if you think this is incorrect, stating the error message.</H4>\n";
exit(0);
  }


exit;



