#!/usr/bin/perl
####################################################################
#                                                                  #
#  DISCLAIMER:                                                     #
#  In no event will T. O' Donnell be liable to the user of this    # 
#  script or any third party for any damages, including any lost   #
#  profits, lost savings or other incidental, consequential or     #
#  special damages arising out of the operation of or inability to # 
#  operate this script, even if the user has been advised of the   # 
#  possibility of such damages.                                    #
####################################################################
##############################################################################
# COPYRIGHT NOTICE                                                           
# TigerTom's Horatio Script. Version: 1.2, April 2002.                 
#                                                                             
# Copyright 2001-2002 T. O' Donnell.  All Rights Reserved.                        
# http://www.tigertom.com/contact.htm                                      
#                                                                            
# This Perl script may be used and modified by any purchaser so               
# long as this copyright notice and the comments below remain intact.
# It may only be used on domains owned by the purchaser.                                                                         
# By using this code you agree to indemnify T. O' Donnell Inc. and T. O' 
# Donnell from any liability that might arise from its use.                                                           
#                                                                           
# Selling the code for this program without prior written consent is       
# expressly forbidden.                                                     
# You must get permission from T. O' Donnell before redistributing this      
# software over the Internet or via any other medium.                                                            
# You may not redistribute an altered version of this program in any form,    
# via any medium.                                                             
#                                                                            
# In all cases copyright and header must remain intact.                     
#                                                                                                
# This Copyright is in full effect in any country that has International     
# Trade Agreements with the United Kingdom Of Great Britain.                 
#                                                                            
##############################################################################

# Horatio HTML page-hiding script by T. O' Donnell, July 2001.
# Copyright T. O' Donnell, July 2001.

use CGI::Carp qw(fatalsToBrowser);
require "tigertom_lib.cgi";
require "horatio_setup.cgi";
require "horatio_lib.cgi";

##################

# Get the (directory and) name of the file to output, from the query string
&parse_data;

# Check Referer
 &check_referer;

# Get the date
# &get_date; 

# Get any cookies
 &get_cookie;

# Set our cookie
 &setCookie;

# Check the browser has got the 'id1' cookie
 &cookie_check;

# Set security string
# &set_security_string;

# Check security string
# &check_security_string;



# Put the 'no-cache' meta tags into a scalar
 $nocache_tags = '<META HTTP-EQUIV="Pragma" Content="No-cache"><META HTTP-EQUIV="expires" CONTENT="Tue, 20 Aug 1996 4:25:27"><META HTTP-EQUIV="Cache Control" Content="no-cache,must-revalidate,no-store"><meta http-equiv="imagetoolbar" content="no">';
 $head_tag = '<HEAD>';

# Put JavaScript 'no-right-click' tag into a scalar
 if($insert_NoRightClickCode) {
 $no_right_click_code = "<script LANGUAGE=\"JavaScript1.1\"> function right\(e\) \{ if \(navigator.appName \=\= \'Netscape\' \&\& \(e.which \=\= 3 \|\| e.which \=\= 2\)\) \{return false\;\} else if \(navigator.appName \=\= \'Microsoft Internet Explorer\' \&\& \(event.button \=\= 2 \|\| event.button \=\= 3\)\) \{ alert\(\"Operation disabled at this web page.\"\)\; return false\; \} return true\; \} document.onmousedown\=right\; document.onmouseup\=right\; if \(document.layers\) window.captureEvents\(Event.MOUSEDOWN\)\;	if \(document.layers\) window.captureEvents\(Event.MOUSEUP\)\; window.onmousedown\=right\; window.onmouseup\=right\; </script>";               
          }
# Get the name of the file to hide

if ($FORM{'target'}) {
  $file_to_hide = "$FORM{'target'}";
    }
else {
$file_to_hide = "$default_file";
      }

# See if the file exists
unless(-e, "$path_to_protected_directory/$file_to_hide") {
print "Content-type: text/html\n\n";
print "<B>ERROR!</B> Can't find requested file $file_to_hide in specified directory $path_to_protected_directory!\n\n"; 
exit(0);
  } # End unless

# Unless they want us to obfuscate more,
# represent the asked-for page:

unless ($FORM{'action'} eq "parse" || $FORM{'action'} eq "parse_obfus") {

$URL = $main_url . $file_to_hide;

print "Location: $URL\n\n";
exit(0);
	
       }
################################ OLD CODE #######################################

######## OLD ABSOLUTE OBFUSCATION CODE SECTION ##########


# Now open the index page, for reading
open (HTMLFILE, "$path_to_protected_directory/$file_to_hide")  || die "Error - cannot open $path_to_protected_directory/$file_to_hide\n";
if($lockit){flock(HTMLFILE,2);}
@lockedhtml=<HTMLFILE>;
if($lockit){flock(HTMLFILE,8);}
close HTMLFILE;

# Print out the page, starting with 'no-cache' headers:

print "Pragma: no-cache", "\n";
print "Expires: 0", "\n";
print "Cache-control: no-cache,must-revalidate,no-store", "\n";
print "Content-type: text/html\n\n";

# If the code is already obfuscated, just print it out
	if($FORM{'action'} eq "parse_obfus") {
	foreach $line(@lockedhtml) {
	print "$line";
		} # end foreach
	exit;
	} # End if


# Check page hasn't already been obscured
# foreach $line(@lockedhtml) {
# if ($line =~ /\<\!--\/\/ HORATIO 2002 \/\/--\>/) {
# $already_done = 1
#      } # End if
#     } # End foreach

# if(!$already_done) {

 if ($move_code) {
# Shove the code down the page, leaving it to appear blank
 print "\n" x 1000 . "\n\n";
	} # End if

  

foreach $line (@lockedhtml){

# Remove newlines
# if($remove_newlines && $ENV{'HTTP_USER_AGENT'} =~ /MSIE/i) {
# Get rid of newlines
# chomp($line);
#	} # End if

if($remove_newlines) {
	# Get rid of newlines and returns
	 $line =~ s/\n//g;
	 $line =~ s/\r//g;
		} # End if

# Insert NO-CACHE meta tags
 if ($insert_nocache) {
 if ($line =~ /$head_tag/i) {
 $line =~ s/$head_tag/$head_tag$nocache_tags$no_right_click_code/gi;
           }
         }

# Substitute full hyperlinks for relative URLs

# First, to the protected directory

 if ($insert_complete_url) {

 if ($line =~ /\<a href=/i && $line !~ /\<a href=\"http/i && $line !~ /\<a href=\"\/cgi-bin/i ) {
 $line =~ s/href=\"/href=\"$main_url/gi;
   } # End unless

 # Then, insert absolute image urls, for those URLs not using horatio_pic.php
  if ( $line =~ /img src=/i && $line !~ /img src=\"http/i && $line !~ /img src=\".?\horatio_pic.php\?.+/i) {
	$line =~ s/src=\"/src=\"$image_url/gi;
           } # End if
    

# Then, insert absolute image urls, for those URLs USING horatio_pic.php
   if($line =~ /img src=\"horatio_pic.php\?.+/i) {
	$line =~ s/src=\"/src=\"$main_url/gi;
           } # End if
 
    } # End if

# Print all lines in the protected html page, *except*  those containing our spider-and-
# ripper-and-robot-blocking code. Note: these latter lines should have no other
# HTML in them, as that will not be printed either!

	# unless ($line =~ /expr=/ || $line =~ /endif/) {
           if ($move_code) {
         # Print lots of 'tabs' on each line
         print "\t" x 200 . "";
                   } # End if

        print "$line";

 	#	} # End unless

	} # End foreach

#     } # End if-not-already-done

#	else { 
#	foreach $line (@lockedhtml){
#	print "$line";
#             } # End foreach
#           } # End else

exit(0);



