#!usr/bin/perl
####################################################################
#                                                                  #
#  DISCLAIMER:                                                     #
#  In no event will T. O' Donnell be liable to the user of this    # 
#  script or any third party for any damages, including any lost   #
#  profits, lost savings or other incidental, consequential or     #
#  special damages arising out of the operation of or inability to # 
#  operate this script, even if the user has been advised of the   # 
#  possibility of such damages.                                    #
####################################################################
##############################################################################
# COPYRIGHT NOTICE                                                          
# TigerTom's Horatio Script. Version: 1.7, Jan. 2003.                    
#                                                                             
# Copyright 2001-2002 T. O' Donnell.  All Rights Reserved.                        
# http://www.tigertom.com/contact.htm                                        
#                                                                           
# This Perl script may be used and modified by any purchaser so              
# long as this copyright notice and the comments below remain intact.                                                     
#                                                                            
# It may only be used on domains directly owned by the purchaser.                     
#                                                                            
# By using this code you agree to indemnify T. O' Donnell Inc. and T. O'    
# Donnell from any liability that might arise from its use.                                                                
#                                                                           
# Selling the code for this program without prior written consent is         
# expressly forbidden.                                                      
# You must get permission from T. O' Donnell before redistributing this      
# software over the Internet or via any other medium.                                                             
# You may not redistribute an altered version of this program in any form,    
# via any medium.                                                             
#                                                                            
# In all cases copyright and header must remain intact.                     
#                                                                                                
# This Copyright is in full effect in any country that has International    
# Trade Agreements with the United Kingdom Of Great Britain.                
#                                                                            
##############################################################################


# File Locking.
# Does your system have file locking ('flock')?  This stops your data 
# files getting corrupted when to different users try to save to the 
# same file simultaneously.  If it does, change the following value to
# 1, e.g. $lockit = 1;. If you're on a Windows server, set it to 0.

$lockit = 0;

# Location of Sendmail program on your server
$mail_prog = '/usr/lib/sendmail';

# Email address to report unusual activity. 
# Put the backward-slash like so, to comment-out the @ sign:

$admin_email = "admin\@tigertom.com";

# Array of valid referring URLS:
@valid_urls = ('tigertom.com','66.33.65.177','tigertom.jaguarpc.com');

# URL of 'horatio_htmlhide.cgi' script:
$horatio_htmlhide_url = "http://www.tigertom.com/cgi-bin/horatio/horatio_htmlhide.cgi";

# Absolute path to parent directory.  NO trailing forward-slash here:
$path_to_parent_directory = "/user/yourserver/absolute/path_to/horatio";

# Absolute path to protected sub-directory.  NO trailing forward-slash here:
$path_to_protected_directory = "/user/yourserver/absolute/path_to/horatio/protected";

# Name of .htaccess file in parent directory
# Comment out the dot:
$pass_file = "\.htaccess";

# Name of header text (html) of pages in the parent directory this script may need 
# to throw up :

$header = 'header.html';

# Name of footer text (html) of pages in the parent directory this script may 
# need to throw up :

$footer = 'footer.html';


# Trunk of URL of protected sub-directory.
# NOTE: YES, use a trailing forward-slash here!: 

$main_url = "http://www.tigertom.com/horatio/protected/";

# Name of your index page in your protected sub-directory.
# This is the page 'horatio_bouncer.cgi' will parse:

$default_file = "your_index.html";

# Trunk of URL within where you keep IMAGES referenced by 
# the index page in the 'protected' sub-directory (this will be used, if necessary 
# to insert absolute URls when the 'horatio_htmlhide.cgi' script parses it)
# NOTE: YES, use a trailing forward-slash here!:

$image_url = "http://www.tigertom.com/horatio/protected/";

# Full URL of 'page2_cookie' page (the page the surfer is directed to
# in the parent directory):

$page2_cookie_url = "http://www.tigertom.com/horatio/page2_cookie.shtml";

################## Password-Hurler Repellent Section #################

# Global path to directory containing .htgroup and/or .htpasswd file
# Note: NO trailing forward-slash here!

  $reg_users_pass_dir = "/user/yourserver/absolute/path_to/cgi-bin/loc/dbase";

# Name of members' group or password file i.e. the file which contains
# the members' usernames. 
# If you have a .htgroup file, use that.  
# If you only have a .htpasswd file, use that. 
# Comment-out the dot in the filename like this, if it's 
# a .htgroup or .htpasswd file.

  $group_file = "\.htgroup";

# File to record access attempts.
# This line assumes the file is in the same directory as the scripts.
  $access_attempt_file = "horatio_access.dat";

# URL to send confused users to (remove the next # to activate):
#  $contact_url = 'http://www.tigertom.com/contact.htm';

# URL to send crackers and lamers to ( remove the next # to activate):
#  $nasty_url = 'http://www.tigertom.com/horatio/nasty.shtml';

########## REPEL PASSWORD TRADERS AND HURLERS ################
#
# Maximum number of accesses we'll allow for the same username on 
# the same day i.e. this may indicate password sharing.
#
# You may need to experiment with this number to find
# the optimum one. It depends on how many times your users are:
#
# a) likely to log in using 'horatio_enter.cgi'
# b) likely to access 'index.shtml' (this page executes 'horatio_bouncer.cgi')
#
# If you are using 'horatio_enter.cgi' only, set this to 45
# If you are using 'horatio_bouncer.cgi' only, set this to 80.
#
# If you are using *both* (overkill!), set this to, say, 160.
#
# Reason: Both scripts record accesses to the same database.
#
# We don't want to bar genuine, frequent, daily users. If a password
# is shared, there'll be *hundreds* of accesses on the same account. 

  $max_login = 10;

# Required form fields in the 'checkpoint' page1_username.shtml form page 
# Leave this value blank if you're not accessing a membership database
# e.g. @required = ();

@required = ('member_name');

####################
## The next two options currently DON'T WORK.
## Make your own on-server backup file!

# Location of Zip program on your server
$zip_loc = '/usr/bin/zip';

# Name of backup zip file we'll be making
$zipname = "horatio_tigertom_content_backup.zip";
###################


############## CODE OBSCURING SECTION ######################

# NOTE: 'horatio_html_obfuscate.cgi' makes permanent changes to your 
# web pages. Always keep a backup of your files, preferably on-server, 
# so you  can unzip it if your pages don't come out right.

######## SIMPLE TRICKS ################

#######
# Do you want the horatio_html_obfuscate.cgi script to insert 
# NO-CACHE tags in the <HEAD> section of of the HTML of 
# web pages it parses? 
# This won't affect the appearance of your code.
# Set the next scalar to "0", if you don't.

 $insert_nocache = 1;

###
# Do you want the horatio_html_obfuscate.cgi script to insert 
# JavaScript 'no-right-click' code in the <HEAD> section of the HTML of 
# web pages it parses? 
# This won't affect the appearance of your code.
# Set the next scalar to "0", if you don't.

 $insert_NoRightClickCode = 1;


###
# Do you want the horatio_htmlhide.cgi to  
# remove 'new-lines' the HTML code of the web pages it parses? 
# This shouldn't affect the appearance of your code.
# Set the next scalar to "0", if it does.

 $remove_newlines = 1;

###
# Do you want the horatio_html_obfuscate.cgi script to attempt to 
# move the HTML code of pages when it
# parses them, to prevent code-plagiarism?  
# This won't affect the appearance of your code. 
# Set the next scalar to "0", if you don't.

$move_code = 1;


#################### Insert Absolute URLs ##################
#
# Do you want the horatio_htmlhide.cgi script to attempt to insert
# absolute URLs into the HTML of your pages, when it
# parses them? This is so any relative URLS in your HTML are re-presented 
# properly by the horatio_htmlhide.cgi script.
#
# WARNING!!: This MAY cause 404 errors / bad links in your web pages. 
# IT'S MUCH BETTER TO INSERT ABSOLUTE URLS BY HAND IN THE ORIGINAL
# DOCUMENT. However, try it and see if it works for you.
# Set the next scalar to "1" or "0", if you do/don't want this feature.

$insert_complete_url = "0";

###################### horatio_html_obfuscate.cgi section ##############
#
# This program is run independently of the rest of the package. It 
# obfuscates the code of the HTML files in the main protected directory.
# Just type:
#
# http://www.yourdomain.com/cgi-bin/horatio/horatio_html_obfuscate.cgi?YourPassword
#
# in your browser.
#
# WARNING!!: This script will obfuscate your code irrevocably, BUT,
# it will make your code much harder to copy.
#
# If this is a 'live' site, you should KEEP A BACKUP ZIP OR TAR file 
# in the protected directory, so you can quickly unzip the
# original files if the obscured pages don't look right.
###################################################################


### URL of horatio_html_hide.cgi

$html_hide_cgi_loc = "/cgi-bin/horatio/horatio_htmlhide.cgi";

######### Convert HTML to JavaScript ################
#
# June 19th 2002. This option now happens automatically. 
# If you don't want  your HTML converted to encoded JavaScript, 
# don't use 'horatio_html_obfuscate.cgi' at all.

################### Password ####################
#
# Password to operate the horatio_html_obfuscate.cgi script.
# CHANGE THIS:
#

$the_password = "G00DScr1Pt";

################## FILE TYPES #######################
#
# Array of file extensions to obfuscate. In this example we're 
# looking for files  with the extension .htm or .html or .shtml. 
#
# You can add others (or remove them) if you follow the 
# pattern here carefully. Note: Don't try to obfuscate CGI, Php or 
# binary files.
#
# The '\' comments out the '.' in the extension, because a '.'
# has a different meaning in Perl in some cases.
#

@FileExtension = ('\.htm','\.html');

################ PROTECT IMAGES ######################
#
# 'horatio_pic.php' stops image files from being cached by
# the browser.
# Do you want the script to replace links to pics with links to 
# <img src="horatio_pic.php?pic_name.gif"> instead?
#
# SETUP horatio_pic.php FIRST! i.e. open it in a text
# editor and read the instructions in it.
#
# Set to 0 if your internal picture links are not all in the
# same directory. Use multiple versions of horatio_pic.php to reference
# your picture files instead.
#
# WARNING!: This feature may cause bad image links in the HTML.
#
 
$insert_horatio_pic_link = 1;


########################### Cookie Setup #################################

# The .htaccess file in the protected directory checks the browser 
# has a cookie. This script sets one.
#
# Change the name and value below to suit your site.
#
# If you change them, BE SURE TO CHANGE THEM IN THE 'PROTECTED' DIRECTORY 
# .HTACCESS FILE.
#
# Set your own browser to 'accept cookies, but notify', and try it out. 
#
# Don't accept the cookie if you want to keep testing this script function. 
#

##  WARNING! If you change the *cookie name and value*, 
##  make sure to change them in 
## 'page2_cookie.shtml' and '.htaccess' (in the protected sub-directory)!

# Cookie name:

$cookie_name = "id1";

# Cookie value

$cookie_value = "valid";
 
# When will the cookie expire from the browser :
# The 05 refers to the year 2005.

$expires = "Wednesday, 09-Nov-05 00:00:00 GMT";

# Domain from which cookies can be set and retrieved.
# Set this to your domain (without the www) prepended with a .
# Change the $domain variable below to your main URL. 
# *Don't forget the dot at the start*! 

$domain = ".tigertom.com";

# Directories in your domain which will be able to retrieve cookies 
# (leave this line as it is to set and retrieve in all directories) :

$path = "/";

# Set this next value to 1 if you want to set a cookie during a SSL
# session.  Otherwise leave it as-is.

$secure = 0;

###################### Email Configuration #################################

# NAME or Company that emails will seem to be be FROM :
$sender_name = "T. O' Donnell Incorporated";

# EMAIL address that emails will seem to be FROM (comment-out the @ with a \) :

$sender_email = "sales\@tigertom.com";



############################## Presentation #############################

# The subject of your order-related emails, and title of any pages 
# this script may need to throw up :

$subject = "Message from TigerTom.Com.";

################################ Security ##################################

# Extra security - this line defines what directories programs 
# can be executed from, on your server, by this script :

$ENV{'PATH'} = '/opt/lib:/opt/bin:/usr/lib:/bin:/usr/bin:/usr/local/bin:/usr/sbin'; 

##### Legitimate length of query string
$legit_length = 300;

######## BAR ANONYMOUS PROXIES ##########

### Location of 'host' program (to check for bad proxies) 
### Leave this blank if you don't want to do this, 
### or you don't have 'host' on your server.
### e.g. $host_prog = "";

$host_prog = '/usr/bin/host';

### List of popular anonymous proxy services hosts we want to ban.
## This list is not comprehensive (it can't be). 

@bad_proxies = ('megagiga','netzero','spaceproxy','anonymizer','drikka',
	 'netdirect','juno','voyager','globali','the-cloak',
          'orangatango','idzap','zapid','proxyone','anonymise.com',
           'dsl.speakeasy.net','adsl.ij.net','cotse',
'somebody','altopia','rewebber','DATA.ISL-ONLINE.DE','KRONENBOURG.FERNUNI-HAGEN.DE',
'goproxy','safeweb','hpro.org','anonymprom','magusnet','secureonlineaccess.he.net',
'rrcnet','myshield','stealth','hidden','hacker','anony',
);


############## Message to anonymous proxy users. ###################

###### Message to anonymous proxy users.
## Comment out the @ in email addresses, and quotation 
## marks, and %, as below.

$alternative_payment_message ="

<TABLE WIDTH=\"60\%\"><TR><TD>

<CENTER>

<H2>ERROR! Anonymous proxies are not acceptable!</H2>
Contact the <a href=\"mailto:$admin_email\">site owner</a>.

</CENTER>

</TD></TR></TABLE></CENTER><BR><BR>


"; # Leave this alone


########## COMPLETE OBFUSCATION SECTION ###########
#
# Insert links to 'horatio_htmlhide.cgi' instead of direct links
# to files in subdirectories of the 'protected' directory?
# e.g. <a href="/cgi-bin/horatio/horatio_htmlhide.cgi?/some/sub-dir/page.html">
# This, with horatio_pic.php, makes sure no files are cached at all.
#
# Set the next scalar to "1" or "0", if you do/don't want this feature.
#
# WARNING!!!: This may cause bad hyperlinks in the HTML.
#
# DON'T SET THIS OPTION UNLESS COMPLETE OBFUSCATION IS ESSENTIAL, and
# you're prepared for some headaches!
#

$insert_horatio_htmlhide_link = 0;



######### Leave this alone
1;
